--- /usr/local/src/asterisk/cvs/zaptel/wcfxo.c	2004-08-10 08:58:14.000000000 +0200
+++ wcfxo.c	2004-08-10 14:37:06.000000000 +0200
@@ -125,6 +125,7 @@
 #ifdef	JAPAN
 	int ohdebounce;
 #endif
+	int readcid;
 	int allread;
 	int regoffset;			/* How far off our registers are from what we expect */
 	int alt;
@@ -189,6 +190,8 @@
 
 static int opermode = 0;
 
+static int dtmf = 0;
+
 static struct fxo_mode {
 	char *name;
 	int ohs;
@@ -327,6 +330,20 @@
 		}
 		/* Look for pegging to indicate ringing */
 		sample = (short)(le32_to_cpu(readchunk[(x << 1) + (1 - wc->alt)]) >> 16);
+		if (dtmf && !wc->readcid && !wc->ringdebounce) {
+			if (sample > 32000) {
+				wc->readcid = 1;
+				if (debug)
+					printk("DTMF CLIP\n");
+				zt_qevent_lock(&wc->chan, ZT_EVENT_DTMFCLIP);
+			}
+			if (sample < -32000) {
+				wc->readcid = 1;
+				if (debug)
+					printk("DTMF CLIP\n");
+				zt_qevent_lock(&wc->chan, ZT_EVENT_DTMFCLIP);
+			}
+		}
 		if ((sample > 32000) && (wc->peg != 1)) {
 			if ((wc->pegtimer < PEGTIME) && (wc->pegtimer > MINPEGTIME))
 				wc->pegcount++;
@@ -606,6 +623,7 @@
 		reg = reg | 0x08;
 		wcfxo_setreg(wc, 0x5, reg);
 		wc->offhook = 0;
+		wc->readcid = 0;
 		/* Don't accept a ring for another 1000 ms */
 		wc->ringdebounce = 1000;
 #ifdef	JAPAN
@@ -1019,6 +1037,7 @@
 MODULE_PARM(boost, "i");
 MODULE_PARM(monitor, "i");
 MODULE_PARM(opermode, "i");
+MODULE_PARM(dtmf, "i");
 MODULE_DESCRIPTION("Wildcard X100P Zaptel Driver");
 MODULE_AUTHOR("Mark Spencer <markster@linux-support.net>");
 #ifdef MODULE_LICENSE
